#!/bin/sh
#
# Scans /proc/bus/input/devices for the given device.
#
# (c) 2004 Darren Salt <linux@youmustbejoking.demon.co.uk>
# GPL v2 or later applies.

# "|"-separated list.
# The first found in the given device's "N:" line will be output.
KEYWORDS='dvb|saa7134'

[ "$1" ] || exit 0

# input device name, less leading "input/"
DEVICE=${1#input/}

exec sed -nre '
  /^I:/ {
    : gather
    N
    /\nH:/! b gather
    /'"$DEVICE"'/ {
      s/^.*\nN:[^\n]*("|\b)('"$KEYWORDS"')("|\b)[^\n]*\n.*$/inputdev/
      T
      p
    }
  }
' < /proc/bus/input/devices

